LeetCode 494. Target Sum(DP,全排)

You are given a list of non-negative integers, a1, a2, ..., an, and a target, S. Now you have 2 symbols + and -. For each integer, you should choose one from + and - as its new symbol.

Find out how many ways to assign symbols to make sum of integers equal to target S.

Example 1:

Input: nums is [1, 1, 1, 1, 1], S is 3. 
Output: 5
Explanation: 

-1+1+1+1+1 = 3
+1-1+1+1+1 = 3
+1+1-1+1+1 = 3
+1+1+1-1+1 = 3
+1+1+1+1-1 = 3

There are 5 ways to assign symbols to make the sum of nums be target 3.

Note:

  1. The length of the given array is positive and will not exceed 20.
  2. The sum of elements in the given array will not exceed 1000.
  3. Your output answer is guaranteed to be fitted in a 32-bit integer.

【问题分析】

1、该问题求解数组中数字只和等于目标值的方案个数,每个数字的符号可以为正或负(减整数等于加负数)。

2、该问题和矩阵链乘很相似,是典型的动态规划问题

3、举例说明: nums = {1,2,3,4,5}, target=3, 一种可行的方案是+1-2+3-4+5 = 3

     该方案中数组元素可以分为两组,一组是数字符号为正(P={1,3,5}),另一组数字符号为负(N={2,4})

     因此: sum(1,3,5) - sum(2,4) = target

              sum(1,3,5) - sum(2,4) + sum(1,3,5) + sum(2,4) = target + sum(1,3,5) + sum(2,4)

              2sum(1,3,5) = target + sum(1,3,5) + sum(2,4)

              2sum(P) = target + sum(nums)

              sum(P) = (target + sum(nums)) / 2

     由于target和sum(nums)是固定值,因此原始问题转化为求解nums中子集的和等于sum(P)的方案个数问题

4、求解nums中子集合只和为sum(P)的方案个数(nums中所有元素都是非负)

      该问题可以通过动态规划算法求解

      举例说明:给定集合nums={1,2,3,4,5}, 求解子集,使子集中元素之和等于9 = new_target = sum(P) = (target+sum(nums))/2

              定义dp[10]数组, dp[10] = {1,0,0,0,0,0,0,0,0,0}

              dp[i]表示子集合元素之和等于当前目标值的方案个数, 当前目标值等于9减去当前元素值

              当前元素等于1时,dp[9] = dp[9] + dp[9-1]

                                            dp[8] = dp[8] + dp[8-1]

                                            ...

                                            dp[1] = dp[1] + dp[1-1]

              当前元素等于2时,dp[9] = dp[9] + dp[9-2]

                                            dp[8] = dp[8] + dp[8-2]

                                            ...

                                            dp[2] = dp[2] + dp[2-2]

              当前元素等于3时,dp[9] = dp[9] + dp[9-3]

                                            dp[8] = dp[8] + dp[8-3]

                                            ...

                                            dp[3] = dp[3] + dp[3-3]

              当前元素等于4时,

                                            ...

              当前元素等于5时,

                                           ...

                                           dp[5] = dp[5] + dp[5-5]

             最后返回dp[9]即是所求的解

#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

class Solution {
public:
    int subsetSum(vector<int>& nums,int s)
    {
        int dp[s+1];  //dp[]为所求和的前面所有可能产生的和
        memset(dp,0,sizeof(dp));
        dp[0]=1;
        for(int i=0;i<nums.size();++i)
        {
            int n=nums[i];
            for(int j=s;j>=n;--j)
            {
                dp[j]=dp[j]+dp[j-n];   //能产生和为的有dp[j]和dp[j-n]+n
            }
        }
        return dp[s];
    }
    /*
    设x为所有正数的和,y为所有负数的和(要减去的正数的和)
    则有方程
    x-y=s     (1)
    x+y=sum   (2)
    由(1),(2)式可得x=(s+sum)/2
    */
    int findTargetSumWays(vector<int>& nums, int s) {
        int sum=0;
        for(int i=0;i<nums.size();i++)
        {
            sum+=nums[i];
        }
        if((s+sum)%2!=0||sum<s)
            return 0;
        else
        {
            return subsetSum(nums,(s+sum)/2);
        }
    }
};
int main()
{
    Solution S;
    int n;
    int num;
    int s;
    vector<int> nums;
    while(~scanf("%d",&n))
    {
        scanf("%d",&s);
        nums.clear();
        for(int i=0;i<n;++i)
        {
            scanf("%d",&num);
            nums.push_back(num);
            //printf("%d",nums[i]);
        }
       printf("%d
",S.findTargetSumWays(nums,s));
    }
    return 0;
}
原文地址:https://www.cnblogs.com/dshn/p/8819063.html